//
//  TimeToStikkitAction.m
//  TimeToStikkit
//
//  Created by Chris Zelenak on 5/1/07.
//  Copyright __MyCompanyName__ 2007. All rights reserved.
//

#import "TimeToStikkitAction.h"

@implementation TimeToStikkitAction

- (QSObject *)performActionOnObject:(QSObject *)dObject{
	NSString *apikey = @"someapikey"; // different for all | extracted real value
	NSString *tag = @" @timesheet";
	
	NSDate *today = [NSDate date];
	NSString *timestring = [NSString stringWithFormat:@" today %@ ", 
		[today descriptionWithCalendarFormat:@"%H:%M %p" 
				timeZone:nil 
				locale:[[NSUserDefaults standardUserDefaults] 
				dictionaryRepresentation]]];

	NSString *post;
	NSMutableURLRequest *request;
	NSURLResponse *response;
	NSData *retvalue;
	NSData *postData;
	NSString *postLength;
	
	
    post = [NSString stringWithFormat:@"raw_text=%@re:%@%@&api_key=%@",
			[self urlEncodeValue:timestring],
			[self urlEncodeValue:[dObject stringValue]],
			[self urlEncodeValue:tag],
			[self urlEncodeValue:apikey]];
	postData = [post dataUsingEncoding:NSASCIIStringEncoding allowLossyConversion:YES];
	postLength = [NSString stringWithFormat:@"%d", [postData length]];

	request = [[[NSMutableURLRequest alloc] init] autorelease];
	
	[request setURL:[NSURL URLWithString:@"http://api.stikkit.com/stikkits.atom"]];
	[request setHTTPMethod:@"POST"];
	[request setValue:postLength forHTTPHeaderField:@"Content-Length"];
	[request setValue:@"application/x-www-form-urlencoded" forHTTPHeaderField:@"Content-Type"];
	[request setHTTPBody:postData];
	
	retvalue = [NSURLConnection sendSynchronousRequest:request returningResponse:&response error:NULL];
	
    return NULL;
}


- (NSString *)urlEncodeValue:(NSString *)str
{
NSString *result = (NSString *) CFURLCreateStringByAddingPercentEscapes(kCFAllocatorDefault, 
			(CFStringRef)str, 
			NULL, 
			CFSTR("?=&+"), 
			kCFStringEncodingUTF8);
return [result autorelease];
}
@end
